import { defineComponent } from 'vue';
import { editorTemplateHtml } from './variables';
import { BooleanEditor } from './boolean-editor';
import { NullEditor } from './null-editor';
import { NumberEditor } from './number-editor';
import { StringEditor } from './string-editor';
import { AnyEditor } from './any-editor';
export var Editor = defineComponent({
    components: {
        'boolean-editor': BooleanEditor,
        'null-editor': NullEditor,
        'number-editor': NumberEditor,
        'string-editor': StringEditor,
        'any-editor': AnyEditor,
    },
    render: editorTemplateHtml,
    props: {
        schema: {
            type: Object,
            required: true,
        },
        initialValue: null,
        title: [String, Number],
        getReference: {
            type: Function,
            required: true,
        },
        theme: {
            type: Object,
            required: true,
        },
        icon: {
            type: Object,
            required: true,
        },
        locale: {
            type: Object,
            required: true,
        },
        readonly: Boolean,
        required: Boolean,
        hasDeleteButton: {
            type: Boolean,
            required: true,
        },
        dragula: Function,
        md: Object,
        hljs: Object,
        forceHttps: Boolean,
        disableCollapse: Boolean,
        noSelect2: Boolean,
        minItemCountIfNeedFilter: Number,
        monacoEditor: Object,
    },
    computed: {
        realSchema: function () {
            if (this.schema.$ref) {
                var reference = this.getReference(this.schema.$ref);
                if (reference) {
                    return reference;
                }
            }
            return this.schema;
        }
    }
});
